蓝桥杯13届 卡牌

问题描述

这天, 小明在整理他的卡牌。

他一共有 n 种卡牌, 第 i 种卡牌上印有正整数数 i(i∈1,n), 且第 i 种卡牌 现有 ai​ 张。

而如果有 n 张卡牌, 其中每种卡牌各一张, 那么这 n 张卡牌可以被称为一 套牌。小明为了凑出尽可能多套牌, 拿出了 m 张空白牌, 他可以在上面写上数 i, 将其当做第 i 种牌来凑出套牌。然而小明觉得手写的牌不太美观, 决定第 i 种牌最多手写 bi​ 张。

请问小明最多能凑出多少套牌?

输入格式

输入共 3 行, 第一行为两个正整数 n,m 。

第二行为 n 个正整数 a1,a2,...,an​ 。

第三行为 n 个正整数 b1,b2,...,bn。

输出格式

一行, 一个整数表示答案。

样例输入

复制代码
4 5
1 2 3 4
5 5 5 5

样例输出

复制代码
3

样例说明

这 5 张空白牌中, 拿 2 张写 1 , 拿 1 张写 2 , 这样每种牌的牌数就变为了 3,3,3,4, 可以凑出 3 套牌, 剩下 2 张空白牌不能再帮助小明凑出一套。

评测用例规模与约定

对于 30% 的数据, 保证 n≤2000;

对于 100% 的数据, 保证 n≤2×; ai,bi≤2n; m≤ 。

从头开始遍历每种纸牌,每遍历一遍 每种纸牌数减1,答案加1

不够减就补,不够补时输出答案

cpp 复制代码
#include<iostream>
using namespace std;

const int N = 2e5+10;
int n;
long long m;

int a[N];
int b[N];
int ans;

int main()
{
	cin>>n>>m;
	for(int i=1; i<=n; ++i) cin>>a[i];
	for(int i=1; i<=n; ++i) cin>>b[i];
	
	int t=1;
	while(t)
	{
		for(int i=1; i<=n; ++i)
		{
			if(a[i]) a[i]--;
			else if(b[i]>0 && m>0)
			{
				b[i]--;
				m--;
			}
			else 
			{
				t = 0;				 
				break;
			}
		}
		
		if(t==0)
		{
			cout<<ans;
			return 0;
		}
		
		ans++;
	}
	
	return 0;
}
相关推荐
MoRanzhi120316 小时前
106.正则问题(分治)
python·算法·正则表达式·蓝桥杯·递归·分治算法·字符串处理
MoRanzhi120320 小时前
122.四平方和(暴力枚举)
python·数学·算法·蓝桥杯·完全平方数·暴力枚举·四平方和定理
Tisfy3 天前
LeetCode 2333.最小差值平方和:排序 + 数学计算(不用二分)
数学·算法·leetcode·题解·贪心·排序
伟大的车尔尼3 天前
贪心题目:单调递增的数字
贪心
Tisfy3 天前
LeetCode 3727.最大交替平方和:排序 (双指针可选)
算法·leetcode·题解·贪心·数组·排序
aqiu1111115 天前
蓝桥杯省一学习计划:每天 2 小时,12 周高效备赛
学习·职场和发展·蓝桥杯
jyyyx的算法博客7 天前
机器人开箱子【贪心 + 模拟】
贪心·模拟
智者知已应修善业10 天前
【51单片机只有一个8*8点阵数据如何滚动起来一片595+一组IO+花样】2022-1-15
c++·经验分享·笔记·单片机·蓝桥杯·硬件架构
伟大的车尔尼10 天前
贪心题目:使绳子变成彩色的最短时间
贪心
Tisfy12 天前
LeetCode 0678.有效的括号字符串:O(n)+O(1)一次遍历
算法·leetcode·字符串·题解·贪心·括号匹配